Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Parameter times : nat -> nat -> nat.
Parameter times_body : nat -> nat -> nat.
Axiom axiom_times : forall (n:nat), connectives.equal (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n).
Definition eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((axiom_times) (n)).
Definition sym_eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) times_body n) (times n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((eq_times) (n)).
Axiom axiom_times_body_O : connectives.equal (nat -> nat) (times_body O) (fun (m:nat) => O).
Definition eq_times_body_O : leibniz.leibniz (nat -> nat) (times_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (times_body O)) (fun (m:nat) => O)) (axiom_times_body_O).
Definition sym_eq_times_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (times_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (times_body O)) (fun (m:nat) => O)) (eq_times_body_O).
Axiom axiom_times_body_S : forall (n:nat), connectives.equal (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)).
Definition eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((axiom_times_body_S) (n)).
Definition sym_eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => plus m (times n m)) (times_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((eq_times_body_S) (n)).
Definition plus_n_O : forall (n:nat), logic.eq (nat) n (plus n O) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) _x_365 (plus _x_365 O))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) x_366 (plus x_366 O)) => ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) (((((((logic.rewrite_l) (nat)) (x_366)) (fun (__:nat) => logic.eq (nat) (S x_366) (S __))) (((logic.refl) (nat)) (S x_366))) (plus x_366 O)) (_x_368))))))) (n).
Definition plus_n_Sm : forall (n:nat), forall (m:nat), logic.eq (nat) (S (plus n m)) (plus n (S m)) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), logic.eq (nat) (S (plus _x_365 m)) (plus _x_365 (S m)))) (fun (m:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus O (S m)))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S m) (y (S m)))) (((logic.refl) (nat)) (S m))))))))) (fun (x_366:nat) => fun (_x_368:forall (m:nat), logic.eq (nat) (S (plus x_366 m)) (plus x_366 (S m))) => (fun (m:nat) => (((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus (S x_366) (S m)))) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (S (plus x_366 m))) (y (S m)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S m))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) __ (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (S (S m))) __)) (((logic.refl) (nat)) (plus x_366 (S (S m))))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 m))) ((_x_368) (m))))))))))) (n).
Definition commutative_plus : relations.commutative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), logic.eq (nat) (plus _x_365 y) (plus y _x_365))) (fun (y:nat) => (((sym_eq_plus) (O)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((sym_eq_plus_body_O) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((((logic.rewrite_l) (nat)) (y)) (fun (__:nat) => logic.eq (nat) y __)) (((logic.refl) (nat)) (y))) (plus y O)) ((plus_n_O) (y))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), logic.eq (nat) (plus x_366 y) (plus y x_366)) => (fun (y:nat) => (((sym_eq_plus) (S x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((sym_eq_plus_body_S) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y (S x_366))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((logic.refl) (nat)) (plus y (S x_366)))) (plus x_366 (S y))) (((((((logic.rewrite_l) (nat)) (S (plus x_366 y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y x_366)) (fun (__:nat) => logic.eq (nat) (S __) (plus y (S x_366)))) (((plus_n_Sm) (y)) (x_366))) (plus x_366 y)) ((_x_368) (y)))) (plus x_366 (S y))) (((plus_n_Sm) (x_366)) (y))))) (S (plus x_366 y))) (((plus_n_Sm) (x_366)) (y)))))))) (n).
Definition associative_plus : relations.associative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus _x_365 y) z) (plus _x_365 (plus y z)))) (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus O y) z) (x (plus y z)))) ((((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (plus y z))) (((logic.refl) (nat)) (plus y z))))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus x_366 y) z) (plus x_366 (plus y z))) => (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus) (S (plus x_366 y))) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus_body_S) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (plus y z))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (plus y z))))) (((logic.refl) (nat)) (S (plus x_366 (plus y z))))) (plus (plus x_366 y) z)) (((_x_368) (y)) (z)))))))))))))) (n).
Definition assoc_plus1 : forall (a:nat), forall (b:nat), forall (c:nat), logic.eq (nat) (plus c (plus b a)) (plus (plus b c) a) := fun (a:nat) => fun (b:nat) => fun (c:nat) => ((((((logic.rewrite_r) (nat)) (plus a b)) (fun (__:nat) => logic.eq (nat) (plus c __) (plus (plus b c) a))) (((((((logic.rewrite_r) (nat)) (plus a (plus b c))) (fun (__:nat) => logic.eq (nat) (plus c (plus a b)) __)) (((((((logic.rewrite_r) (nat)) (plus a (plus b c))) (fun (__:nat) => logic.eq (nat) __ (plus a (plus b c)))) (((logic.refl) (nat)) (plus a (plus b c)))) (plus c (plus a b))) (((((((logic.rewrite_l) (nat)) (plus (plus a b) c)) (fun (__:nat) => logic.eq (nat) (plus c (plus a b)) __)) (((commutative_plus) (c)) (plus a b))) (plus a (plus b c))) ((((associative_plus) (a)) (b)) (c))))) (plus (plus b c) a)) (((commutative_plus) (plus b c)) (a)))) (plus b a)) (((commutative_plus) (b)) (a)).
Definition distributive_times_plus : relations.distributive (nat) times plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), forall (z:nat), logic.eq (nat) (times _x_365 (plus y z)) (plus (times _x_365 y) (times _x_365 z)))) ((((sym_eq_times) (O)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (times O (plus y z)) (plus (times O y) (x z)))) ((((sym_eq_times) (O)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (times O (plus y z)) (plus (x y) (filter_nat_type (nat -> nat) times_body O z)))) ((((sym_eq_times) (O)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (x (plus y z)) (plus (filter_nat_type (nat -> nat) times_body O y) (filter_nat_type (nat -> nat) times_body O z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (x (plus y z)) (plus (filter_nat_type (nat -> nat) times_body O y) (filter_nat_type (nat -> nat) times_body O z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (times_body O (plus y z)) (plus (x y) (filter_nat_type (nat -> nat) times_body O z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (times_body O (plus y z)) (plus (times_body O y) (x z)))) (((sym_eq_times_body_O) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (times_body O (plus y z)) (plus (times_body O y) (x z)))) (((sym_eq_times_body_O) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (times_body O (plus y z)) (plus (x y) O))) (((sym_eq_times_body_O) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) (x (plus y z)) (plus O O))) ((((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) O (x O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) O (x O))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => forall (y:nat), forall (z:nat), logic.eq (nat) O (x O))) (fun (_y:nat) => fun (_z:nat) => ((logic.refl) (nat)) (O))))))))))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), forall (z:nat), logic.eq (nat) (times x_366 (plus y z)) (plus (times x_366 y) (times x_366 z))) => (fun (y:nat) => fun (z:nat) => (((sym_eq_times) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (times (S x_366) (plus y z)) (plus (times (S x_366) y) (x z)))) ((((sym_eq_times) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (times (S x_366) (plus y z)) (plus (x y) (filter_nat_type (nat -> nat) times_body (S x_366) z)))) ((((sym_eq_times) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (x (plus y z)) (plus (filter_nat_type (nat -> nat) times_body (S x_366) y) (filter_nat_type (nat -> nat) times_body (S x_366) z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (x (plus y z)) (plus (filter_nat_type (nat -> nat) times_body (S x_366) y) (filter_nat_type (nat -> nat) times_body (S x_366) z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (times_body (S x_366) (plus y z)) (plus (x y) (filter_nat_type (nat -> nat) times_body (S x_366) z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (times_body (S x_366) (plus y z)) (plus (times_body (S x_366) y) (x z)))) ((((sym_eq_times_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (times_body (S x_366) (plus y z)) (plus (times_body (S x_366) y) (x z)))) ((((sym_eq_times_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (times_body (S x_366) (plus y z)) (plus (x y) (plus z (times x_366 z))))) ((((sym_eq_times_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (x (plus y z)) (plus (plus y (times x_366 y)) (plus z (times x_366 z))))) (((((((logic.rewrite_r) (nat)) (plus y (plus z (times x_366 (plus y z))))) (fun (__:nat) => logic.eq (nat) __ (plus (plus y (times x_366 y)) (plus z (times x_366 z))))) (((((((logic.rewrite_r) (nat)) (plus y (plus (times x_366 y) (plus z (times x_366 z))))) (fun (__:nat) => logic.eq (nat) (plus y (plus z (times x_366 (plus y z)))) __)) (((((((logic.rewrite_r) (nat)) (plus z (plus (times x_366 y) (times x_366 z)))) (fun (__:nat) => logic.eq (nat) (plus y (plus z (times x_366 (plus y z)))) (plus y __))) (((((((logic.rewrite_l) (nat)) (times x_366 (plus y z))) (fun (__:nat) => logic.eq (nat) (plus y (plus z (times x_366 (plus y z)))) (plus y (plus z __)))) (((logic.refl) (nat)) (plus y (plus z (times x_366 (plus y z)))))) (plus (times x_366 y) (times x_366 z))) (((_x_368) (y)) (z)))) (plus (times x_366 y) (plus z (times x_366 z)))) (((((((logic.rewrite_l) (nat)) (plus (plus z (times x_366 y)) (times x_366 z))) (fun (__:nat) => logic.eq (nat) (plus (times x_366 y) (plus z (times x_366 z))) __)) ((((assoc_plus1) (times x_366 z)) (z)) (times x_366 y))) (plus z (plus (times x_366 y) (times x_366 z)))) ((((associative_plus) (z)) (times x_366 y)) (times x_366 z))))) (plus (plus y (times x_366 y)) (plus z (times x_366 z)))) ((((associative_plus) (y)) (times x_366 y)) (plus z (times x_366 z))))) (plus (plus y z) (times x_366 (plus y z)))) ((((associative_plus) (y)) (z)) (times x_366 (plus y z))))))))))))))) (n).
